<?php
class InvoiceController extends hikashopController {

	public function __construct($config = array()) {
		parent::__construct($config);
		return $this->generate();
	}

	// http://www.monsite.com/administrator/index.php?option=com_hikashop&ctrl=invoice&year=2011&month=7&tva=trimestre
	// http://www.monsite.com/administrator/index.php?option=com_hikashop&ctrl=invoice&year=2011&month=10&tva=trimestre
	public function generate() {
		$this->month = JRequest::getInt('month');
		$this->last_month = JRequest::getInt('last_month');
		if(empty($this->month)){
			echo '<html><head></head><body><ul>';
			echo '<li><a href="index.php?option=com_updateme&ctrl=invoice&month='.date('n').'&tva=trimestre" >Factures Trimestre</a></li>';
			echo '<li><a href="index.php?option=com_updateme&ctrl=invoice&month='.date('n').'&tva=bilan" >Factures Bilan</a></li>';
			echo '<li><a href="index.php?option=com_updateme&ctrl=invoice&month='.date('n').'" >Factures Mois de '.date('F').' '.date('Y').'</a></li>';
			echo '<li><a href="index.php?option=com_updateme&ctrl=des&month='.date('n').'" >DES Mois de '.date('F').' '.date('Y').'</a></li>';
			if(date('n') == 1){
				echo '<li><a href="index.php?option=com_updateme&ctrl=invoice&month=12&year='.(date('Y')-1).'" >Factures Mois de 12 / '.(date('Y')-1).'</a></li>';
			}else{
				echo '<li><a href="index.php?option=com_updateme&ctrl=invoice&month='.(date('n')-1).'" >Factures Mois de '.(date('n')-1).' / '.date('Y').'</a></li>';
			}
			/*for($i = 2009;$i <= date('Y');$i++){
				echo '<li><a href="index.php?option=com_updateme&ctrl=des&month=-1&year='.$i.'" >DES Année '.$i.'</a></li>';
			}*/
			echo '<li><a target="_blank" href="https://pro.douane.gouv.fr/prodouane.asp">https://pro.douane.gouv.fr/prodouane.asp</a></li>';
			echo '</ul></body></html>';
			exit;
		}
		$this->year = JRequest::getInt('year',date('Y'));
		$this->last_year = JRequest::getInt('last_year');

		$this->tva = JRequest::getWord('tva','');

		$minDate = $this->year.'-'.$this->month.'-01 00:00:00';
		if(!empty($this->last_year)){
			if(empty($this->last_month)){
				$this->last_month=$this->month;
			}
			$maxDate = $this->last_year.'-'.$this->last_month.'-01 00:00:00';
		}else{
	 		if($this->tva=='bilan'){
				$maxDate = ($this->year+1).'-'.$this->month.'-01 00:00:00';
			}elseif($this->tva=='trimestre'){
				$last_month = $this->month+3;
				$last_year = $this->year;
				if($last_month>12){
					$last_month = $last_month-12;
					$last_year = $last_year+1;
				}
				$maxDate = $last_year.'-'.($last_month).'-01 00:00:00';
			}else{
				$maxDate = ($this->month == 12) ? ($this->year+1).'-01-01 00:00:00' : $this->year.'-'.($this->month+1).'-01 00:00:00';
	 		}
		}

		$db = JFactory::getDBO();
		//we load the orders...
		$db->setQuery('SELECT hikaorder.*, currency.currency_code, address.* FROM #__hikashop_order as hikaorder LEFT JOIN #__hikashop_currency as currency on currency.currency_id = order_currency_id LEFT JOIN #__hikashop_address as address on order_billing_address_id = address.address_id WHERE order_created >= '.updateme::getTime($minDate).' AND order_created < '.updateme::getTime($maxDate).' AND order_status=\'confirmed\' AND order_type IN (\'partner\',\'sale\') ORDER BY order_id');
		$orders = $db->loadObjectList();

		//We load the product prices...
		$db->setQuery('SELECT price_product_id,price_value,price_min_quantity FROM #__hikashop_price ORDER BY price_min_quantity ASC');
		$allprices = $db->loadObjectList();

		//Handle discount for AcyMailing 5 Licences pack product
		foreach($allprices as $i => $onePrice){
			if($onePrice->price_product_id == 6 && $onePrice->price_value > 400){
				$allprices[$i]->price_value = 314.65;
			}
		}

		@ob_clean();

		header("Pragma: public");
		header("Expires: 0"); // set expiration time
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Content-Type: application/force-download");
		header("Content-Type: application/octet-stream");
		header("Content-Type: application/download");
		header("Content-Disposition: attachment; filename=Factures_".UPDATEME_WEBSITE."_".$this->year."_".($this->month < 10 ? '0' : '').$this->month.".csv;");
		header("Content-Transfer-Encoding: binary");

		echo "Numero;Facture;Date;Client;Entreprise;Num TVA;Adresse;Code postal;Ville;Pays;Zone TVA;Num compta;Prix HT EUR;Taxe EUR;Prix TTC EUR;Com. Paypal;Devise origine;Moyen de paiement"."\n";

		$totaux = array();
		$totaux['fr'] = array('subtotal'=>0,'vat'=>0,'total'=>0,'compaypal'=>0);
		$totaux['eu_vat'] = array('subtotal'=>0,'vat'=>0,'total'=>0,'compaypal'=>0);
		$totaux['eu_valid'] = array('subtotal'=>0,'vat'=>0,'total'=>0,'compaypal'=>0);
		$totaux['out_eu'] = array('subtotal'=>0,'vat'=>0,'total'=>0,'compaypal'=>0);

		$commissions = array();
		$commissions['paypal']['EUR'] = array('pourcent' => '3.4' ,'fix' => '0.25');
		$commissions['paypal']['USD'] = array('pourcent' => '3.9' ,'fix' => '0.3');

		//Variable to handle all errors, they will be displayed at the end of the exported file.
		$errors = array();

		//Variable to save all payment methods used.
		$paymentmethods = array();

		//Latest conversion rate...
		$latestRate = 0;

		foreach($orders as $oneOrder){
			//No amout? Maybe a free product?
			if(intval($oneOrder->order_full_price) == 0) continue;

			echo $oneOrder->order_id.";".$oneOrder->order_number.";".updateme::getDate($oneOrder->order_created,'%d/%m/%Y').";";
			echo @iconv('UTF-8','ISO-8859-1//IGNORE',html_entity_decode($oneOrder->address_lastname.' '.$oneOrder->address_firstname.";".$oneOrder->address_company.";".$oneOrder->address_vat.";"));
			echo @iconv('UTF-8','ISO-8859-1//IGNORE',html_entity_decode('"'.$oneOrder->address_street.'";'.$oneOrder->address_post_code.";".$oneOrder->address_city.";".getCountryName($oneOrder->address_country).";"));

			if($oneOrder->currency_code == 'USD'){

				//We get the conversion rate by loading one product of the order
				$db->setQuery('SELECT product_id,order_product_quantity,order_product_price FROM #__hikashop_order_product WHERE order_id = '.$oneOrder->order_id.' ORDER BY order_product_price DESC LIMIT 1');
				$oneProduct = $db->loadObject();

				if(empty($oneProduct->product_id)){
					$errors[] = 'ORDER '.$oneOrder->order_id.' total '.num($oneOrder->order_full_price).'USD ??No product??';
					if(empty($latestRate)){
						echo "\n";
						continue;
					}
				}

				//We need to transform USD into EUR for the total amount and the commission.
				if(!empty($oneProduct->product_id)){
					$euroPrice = 0;
					foreach($allprices as $onePrice){
						if($onePrice->price_product_id == $oneProduct->product_id && $onePrice->price_min_quantity <= $oneProduct->order_product_quantity){
							$euroPrice = $onePrice->price_value;
						}
					}

					if(empty($euroPrice)){
						$errors[] = 'ORDER '.$oneOrder->order_id.' total '.num($oneOrder->order_full_price).'USD ??No euro price??';
						echo "\n";
						continue;
					}

					$oneOrder->order_full_price = $oneOrder->order_full_price*($euroPrice / $oneProduct->order_product_price);
					$latestRate = $euroPrice / $oneProduct->order_product_price;
				}else{
					$oneOrder->order_full_price = $oneOrder->order_full_price*$latestRate;
				}

			}

			$oneOrder->order_sub_price = $oneOrder->order_full_price;
			$oneOrder->order_tax = 0;
			$oneOrder->compaypal = 0;

			if($oneOrder->order_payment_method == 'paypal'){
				$oneOrder->compaypal = $commissions['paypal'][$oneOrder->currency_code]['pourcent']*$oneOrder->order_full_price/100 + $commissions['paypal'][$oneOrder->currency_code]['fix'];
			}

			if((empty($oneOrder->address_vat) && isEuropean($oneOrder->address_country)) || strpos($oneOrder->address_country,'France')){
				//Since January 1st 2014 the French VAT is 20%
				if($oneOrder->order_created > 1388530800){
					$taxeRate = 20;
				}else{
					$taxeRate = 19.6;
				}
				$oneOrder->order_sub_price = $oneOrder->order_full_price / (1+($taxeRate/100));
				$oneOrder->order_tax = $oneOrder->order_full_price - $oneOrder->order_sub_price;
			}

			if($oneOrder->order_type == 'partner'){
				//We remove the order...
				$oneOrder->order_full_price = - $oneOrder->order_full_price;
				$oneOrder->order_tax = 0;
				$oneOrder->compaypal = 0;
				$oneOrder->order_sub_price = $oneOrder->order_full_price;
			}

			if(empty($oneOrder->order_payment_method)){
				$errors[] = 'ORDER '.$oneOrder->order_id.' with no payment method';
			}

			if(!isset($totaux['eu_vat']['total_'.$oneOrder->order_payment_method])){
				$paymentmethods[] = $oneOrder->order_payment_method;
				$totaux['fr']['total_'.$oneOrder->order_payment_method] = 0;
				$totaux['fr']['vat_'.$oneOrder->order_payment_method] = 0;
				$totaux['fr']['subtotal_'.$oneOrder->order_payment_method] = 0;

				$totaux['eu_vat']['total_'.$oneOrder->order_payment_method] = 0;
				$totaux['eu_vat']['vat_'.$oneOrder->order_payment_method] = 0;
				$totaux['eu_vat']['subtotal_'.$oneOrder->order_payment_method] = 0;

				$totaux['eu_valid']['total_'.$oneOrder->order_payment_method] = 0;
				$totaux['eu_valid']['vat_'.$oneOrder->order_payment_method] = 0;
				$totaux['eu_valid']['subtotal_'.$oneOrder->order_payment_method] = 0;

				$totaux['out_eu']['total_'.$oneOrder->order_payment_method] = 0;
				$totaux['out_eu']['vat_'.$oneOrder->order_payment_method] = 0;
				$totaux['out_eu']['subtotal_'.$oneOrder->order_payment_method] = 0;
			}


			if(strpos($oneOrder->address_country,'France')){
				//France
				$totaux['fr']['subtotal'] += $oneOrder->order_sub_price;
				$totaux['fr']['total'] += $oneOrder->order_full_price;
				$totaux['fr']['vat'] += $oneOrder->order_tax;
				$totaux['fr']['compaypal'] += $oneOrder->compaypal;
				$totaux['fr']['total_'.$oneOrder->order_payment_method] += $oneOrder->order_full_price;
				$totaux['fr']['vat_'.$oneOrder->order_payment_method] += $oneOrder->order_tax;
				$totaux['fr']['subtotal_'.$oneOrder->order_payment_method] += $oneOrder->order_sub_price;
				echo '1;706100;';
			}elseif(!empty($oneOrder->order_tax)){
				//European Union without vat number
				$totaux['eu_vat']['subtotal'] += $oneOrder->order_sub_price;
				$totaux['eu_vat']['total'] += $oneOrder->order_full_price;
				$totaux['eu_vat']['vat'] += $oneOrder->order_tax;
				$totaux['eu_vat']['compaypal'] += $oneOrder->compaypal;
				$totaux['eu_vat']['total_'.$oneOrder->order_payment_method] += $oneOrder->order_full_price;
				$totaux['eu_vat']['vat_'.$oneOrder->order_payment_method] += $oneOrder->order_tax;
				$totaux['eu_vat']['subtotal_'.$oneOrder->order_payment_method] += $oneOrder->order_sub_price;
				echo '3;706122;';
			}elseif(isEuropean($oneOrder->address_country)){
				//European Union with valid vat number
				$totaux['eu_valid']['subtotal'] += $oneOrder->order_sub_price;
				$totaux['eu_valid']['total'] += $oneOrder->order_full_price;
				$totaux['eu_valid']['vat'] += $oneOrder->order_tax;
				$totaux['eu_valid']['compaypal'] += $oneOrder->compaypal;
				$totaux['eu_valid']['total_'.$oneOrder->order_payment_method] += $oneOrder->order_full_price;
				$totaux['eu_valid']['vat_'.$oneOrder->order_payment_method] += $oneOrder->order_tax;
				$totaux['eu_valid']['subtotal_'.$oneOrder->order_payment_method] += $oneOrder->order_sub_price;
				echo '2;706123;';
			}else{
				//Out of europe
				$totaux['out_eu']['subtotal'] += $oneOrder->order_sub_price;
				$totaux['out_eu']['total'] += $oneOrder->order_full_price;
				$totaux['out_eu']['vat'] += $oneOrder->order_tax;
				$totaux['out_eu']['compaypal'] += $oneOrder->compaypal;
				$totaux['out_eu']['total_'.$oneOrder->order_payment_method] += $oneOrder->order_full_price;
				$totaux['out_eu']['vat_'.$oneOrder->order_payment_method] += $oneOrder->order_tax;
				$totaux['out_eu']['subtotal_'.$oneOrder->order_payment_method] += $oneOrder->order_sub_price;
				echo '4;706121;';
			}

			echo num($oneOrder->order_sub_price).';'.num($oneOrder->order_tax).';'.num($oneOrder->order_full_price).';';

			echo empty($oneOrder->compaypal) ? '' : num($oneOrder->compaypal);

			echo ';'.$oneOrder->currency_code.';'.$oneOrder->order_payment_method;

			echo "\n";
		}

		$totaux['final']['subtotal'] = ($totaux['out_eu']['subtotal'] + $totaux['eu_valid']['subtotal'] + $totaux['eu_vat']['subtotal'] + $totaux['fr']['subtotal']);
		$totaux['final']['total'] = ($totaux['out_eu']['total'] + $totaux['eu_valid']['total'] + $totaux['eu_vat']['total'] + $totaux['fr']['total']);
		$totaux['final']['vat'] = ($totaux['out_eu']['vat'] + $totaux['eu_valid']['vat'] + $totaux['eu_vat']['vat'] + $totaux['fr']['vat']);
		$totaux['final']['compaypal'] = ($totaux['out_eu']['compaypal'] + $totaux['eu_valid']['compaypal'] + $totaux['eu_vat']['compaypal'] + $totaux['fr']['compaypal']);

		foreach($totaux as $type => $values){
			foreach($values as $type2 => $value){
				$totaux[$type][$type2] = number_format($value, 2, ',', ' ');
			}
		}

		echo "\n\n\n";
		echo ";;;;;;;;;;;Total HT;TVA;Total TTC;Com. Paypal\n";
		echo ";;;;;;;;;France;;".$totaux['fr']['subtotal'].";".$totaux['fr']['vat'].";".$totaux['fr']['total'].";".$totaux['fr']['compaypal']."\n";
		echo ";;;;;;;;;Intra Com. avec TVA;;".$totaux['eu_vat']['subtotal'].";".$totaux['eu_vat']['vat'].";".$totaux['eu_vat']['total'].";".$totaux['eu_vat']['compaypal']."\n";
		echo ";;;;;;;;;Intra Com. sans TVA;;".$totaux['eu_valid']['subtotal'].";".$totaux['eu_valid']['vat'].";".$totaux['eu_valid']['total'].";".$totaux['eu_valid']['compaypal']."\n";
		echo ";;;;;;;;;Hors Union Europeenne;;".$totaux['out_eu']['subtotal'].";".$totaux['out_eu']['vat'].";".$totaux['out_eu']['total'].";".$totaux['out_eu']['compaypal']."\n";
		echo ";;;;;;;;;TOTAL;;".$totaux['final']['subtotal'].";".$totaux['final']['vat'].";".$totaux['final']['total'].";".$totaux['final']['compaypal'];

		foreach($paymentmethods as $oneMethod){
			echo "\n\n";
			echo "Paiement par ".$oneMethod.";;;;Total HT;TVA;Total TTC\n";
			echo ";France;;;".$totaux['fr']['subtotal_'.$oneMethod].";".$totaux['fr']['vat_'.$oneMethod].";".$totaux['fr']['total_'.$oneMethod]."\n";
			echo ";Intra Com. avec TVA;;;".$totaux['eu_vat']['subtotal_'.$oneMethod].";".$totaux['eu_vat']['vat_'.$oneMethod].";".$totaux['eu_vat']['total_'.$oneMethod]."\n";
			echo ";Intra Com. sans TVA;;;".$totaux['eu_valid']['subtotal_'.$oneMethod].";".$totaux['eu_valid']['vat_'.$oneMethod].";".$totaux['eu_valid']['total_'.$oneMethod]."\n";
			echo ";Hors Union Europeenne;;;".$totaux['out_eu']['subtotal_'.$oneMethod].";".$totaux['out_eu']['vat_'.$oneMethod].";".$totaux['out_eu']['total_'.$oneMethod]."\n";
		}

		echo "\n\n\n";
		if(!empty($errors)){
			echo "Errors : ;".implode(";"."\n",$errors);
		}
		exit;
	}
}

function isEuropean($countryCode){
	$eucoutries = array(
		'country_Germany_81','country_Austria_14', 'country_Belgium_21', 'country_Bulgaria_33',
		'country_Cyprus_55', 'country_Denmark_57', 'country_Spain_195',
		'country_Estonia_67', 'country_Finland_72', 'country_France_73',
		'country_France__Metropolitan_74', 'country_United_Kingdom_222',
		'country_Greece_84', 'country_Hungary_97', 'country_Ireland_103',
		'country_Italy_105', 'country_Latvia_117', 'country_Lithuania_123',
		'country_Luxembourg_124', 'country_Malta_132',
		'country_Netherlands_150', 'country_Poland_170',
		'country_Portugal_171', 'country_Czech_Republic_56',
		'country_Romania_175', 'country_Slovakia_189', 'country_Slovenia_190',
		'country_Sweden_203'
	);
	if(in_array($countryCode,$eucoutries))
		return true;
	return false;
}

function getCountryName($code) {
	$code = substr($code,strpos($code,'_')+1);
	$code = substr($code,0,strrpos($code,'_'));
	return str_replace(array('_'),' ',$code);
}

function num($price) {
	return number_format($price, 2, ',', ' ');
}